CoCoA-5 - Feature #1272

Groebner Bases over ZZ
18 Apr 2019 17:26 - Anna Maria Bigatti

Status: Closed Start date: 18 Apr 2019
Priority: Normal Due date:

Assignee: John Abbott % Done: 100%
Category: CoCoA-5 function: new Estimated time: 14.99 hours
Target version: CoCoA-5.4.0 Spent time: 14.85 hours
Description

Write a basic implementation for Groebner Bases over the integers

Related issues:

Related to CoCoALib - Feature #1635: NR for polys with coeffs in PID In Progress 25 Nov 2021
Related to CoCoALib - Feature #1667: GBasis over ZZ: port to CoCoALib In Progress 16 Feb 2022
History

#1 - 18 Apr 2019 17:36 - Anna Maria Bigatti

- Category set to CoCoA-5 function: new

As a starting point Elisa Palezzato noticed a bug in NR: it does not check the ring of coefficients is a field.

#2 - 18 Apr 2019 17:49 - Anna Maria Bigatti
NR bug:

/**/ use ZZI[x,v];
/**/ NR(x"2, [2*x"2-1]1);
0

very odd, very wrong

#3 - 18 Apr 2019 18:10 - Anna Maria Bigatti
Very subtle: it gets to this

void RingZZImpl::myDiv (RawPtr rawlhs, ConstRawPtr rawx, ConstRawPtr rawy) const
{

CoCoA_ASSERT (!myIsZero (rawy)) ;

mpz_divexact (import (rawlhs), import (rawx), import (rawy));

}

so 1/2 is 0, then computes x2 - 0*(2*x"2-1), but skipping the two leading monomials.
Now, where should | put the check? and which check?
In fact, if the divisors were monic, it works fine in theory and practice.
#4 - 23 May 2019 11:17 - John Abbott

Florian Walsh (Passau) has an prototype implementation of GBasis over ZZ, currently as a package in CoCoA-5. He is willing to donate it to us.

#5 - 24 May 2019 04:18 - Elisa Palezzato

We also wrote a prototype implementation of GBasis over ZZ. In particular we focused on minimal strong GBasis. Maybe it could be useful as a
comparison.

#6 - 29 May 2019 11:43 - Florian Walsh
- File GBasisZ.cpkg5 added

So here is my implementation. It is based on this thesis https:/kluedo.ub.uni-kl.de/files/4457/phd.pdf by A. Popescu.
So far | didn't implement any of the optimizations. Please let me know if you find bugs or have suggestions for improvement.

| also have some functions (in CoCoA 4) for computing the intersection, quotient and saturation of Ideals over ZZ.
If you are interested | can port them to CoCoA 5.

#7 - 29 May 2019 11:53 - Anna Maria Bigatti

Florian Walsh wrote:

So here is my implementation. It is based on this thesis https:/kluedo.ub.uni-kl.de/files/4457/phd.pdf by A. Popescu.

Good!
if you and Elisa agree, you could compare/merge your code(s).

#8 - 30 May 2019 04:38 - Elisa Palezzato

| have to prepare the package, now it is just a collection of functions. After that for me is fine, we can do it!

Elisa

#9 - 04 Jun 2019 05:40 - Elisa Palezzato
- File GBoverZZ.cpkgh added

In order to minimize the output of the GB we added the reduction via the GCD of the LCs to the computation of the minimal strong GB.

Given the following properties:

1) the ideal generated by the leading monomials of polynomials in | equals the ideal generated by the leading monomials of G;
2) the leading monomial of any polynomial in | is divisible by the leading monomial of some polynomial in G;

our output verify 1) and not 2).

Here we have an example of different results:

/**/ use ZZ|[x,y,z];
/** G = [2*x+2%y, 3"y, x"3+3"y];
/**/ indent(GBoverZZ(G));

[
3%y,

14 May 2024 2/6


https://kluedo.ub.uni-kl.de/files/4457/phd.pdf
https://kluedo.ub.uni-kl.de/files/4457/phd.pdf

2*x +2%y,
y"3 +6%y,
x"3 +3*y

]

/**/ indent(MinimalGBasisZ(G));
[

2*x +2%y,
3%y,

x"3 +3%y,
Xy -2"yh2,
y"3 +6*y

]

The poly x*y -2*y2 is equal to -y*(2*x +2*y) + X*(3™y).

| attach the package below.

#10 - 17 Jun 2019 05:45 - Elisa Palezzato
- File GBoverZZ.cpkg5 added

We modified our package following Robbiano's examples that you can find below.

use ZZ[x.y,z];
f1 1= xh2-2%y;
f2 = X*y+3*z+1;
f3 ;= z"2+5%x;

GBoverzZZ([f1,f2,f3]);

- [272 +5%X, 2*yM2 +3*X*Z +X, X'y +3*Z +1, x"2 - 2*y]

GBasisZ([f1,12,3]);

- [x"2 - 2%, x*y +3*z +1, z"2 +5"x, -2*y"2 -3"x*z -X]

use ZZ[x.y];

GBoverZZ([3*y - 1, 6*x - 1]);

- [B%y -1, -2 +y, X'y +y"2-X]
GBasisZ([3"y - 1, 6*x - 1]);

--[8*y -1, 6"x -1, - 2" +y, X'y +y"2 -X]

To be noted:

- both packages work only on ZZ. For our package (GBoverZZ) this is due to the fact that gcd(3*y,6*x)=1 over QQ[x,y].
- Over ZZ does not exist yet the type ideal. For the moment the input of the GB must be a list.
#11 - 19 Jun 2019 09:21 - Elisa Palezzato
- File GBoverZZ.cpkg5 added

Few bugs fixed.
We separated GBoverZZ and MinimalGBoverZZ.

#12 - 29 Aug 2019 12:17 - Florian Walsh
- File GBasisZ.cpkg5 added

Changes to the previous version:

- some code cleanup

- fix bug in the ExtendedGBoverZZ function

- add functions IsNecessaryGcdPair and IsNecessarySPair to avoid considering unecessary pairs
- merge some functions/ideas from the other GBoverZZ implementation

#13 - 02 Mar 2020 22:07 - John Abbott
- Target version changed from CoCoA-5.?.7 to CoCoA-5.4.0

#14 - 25 Nov 2021 16:47 - John Abbott
- Related to Feature #1635: NR for polys with coeffs in PID added

#15 - 02 Feb 2022 16:49 - John Abbott
- Status changed from New to In Progress

- % Done changed from 0 to 10

What is the status of this issue?

Is the latest version of the code above more-or-less ready to be included in a release?
Thanks!

Be warned: | am about to download the code and start playing with it... | may even give it to my students!

#16 - 02 Feb 2022 20:17 - John Abbott
- File GBasisZ-20220202.cpkg5 added

| have done some cleaning in the code, and have added a SortBy to the list of pairs.
It seems to make the code run usefully faster (in some cases, anyway).

I'll try to attach the new version.

#17 - 02 Feb 2022 20:52 - John Abbott

To be ale to tackle non-trivial examples, it would be very helpful to have a way of reducing polynomials modulo any constant which we happen to find.
Trying to do this while also computing quotients in NRoverZZCore could be tricky... maybe it is not so necessary there?

#18 - 02 Feb 2022 22:36 - John Abbott
- % Done changed from 10 to 20

| have a first version with modulus. | think it is probably faster, but still impressively slow :-/
I'll wait a bit before uploading it.

#19 - 03 Feb 2022 16:53 - John Abbott

What is the future of this package?
Florian is now rather busy with other things, so cannot in the foreseeable future do much more.
Perhaps the same applies to Elisa and Michele?

Many of the operations are actually quite "low level", so a translation into C++ would
likely produce a noticeable speed gain.

| am anticipating a work-load which will preclude me from doing anything for CoCoA for

the next 6+ months... that means I'll do nothing (not even emergency bug fixes).
All thanks to the administrators' daft rules about measuring how much work one does.

#20 - 03 Feb 2022 19:14 - John Abbott

So that we do not lose what has been done....
| suggest making the existing code into an official package; we should document at least 1 function (MinimalGBoverZZ -- what name??)

| fear there is no maintainer (so it lands on my desk).

#21 - 04 Feb 2022 14:34 - John Abbott
- % Done changed from 20 to 50

| have documented MinGBoverZZ but no other function. It is clearly marked as [PROTOTYPE].
The package is now called prototype-GBZZ.cpkg5.
I shall check in shortly. The hope is not to lose this code... though it is not really ready for public release.

#22 - 16 Feb 2022 19:57 - John Abbott
- Assignee set to John Abbott

- % Done changed from 50 to 100

- Estimated time set to 14.99 h

I'll close this as it is now in CVS, and should be in the next release (with 1 fn documented).
It could be a good student project to convert it to C++, and make it more efficient!

I'll make a new issue about the conversion to C++.

Closing.

#23 - 16 Feb 2022 20:00 - John Abbott
- Related to Feature #1667: GBasis over ZZ: port to CoCoALib added

#24 - 17 Feb 2022 21:22 - John Abbott

- Status changed from In Progress to Closed

Files

GBasisZ.cpkg5 9.88 KB 29 May 2019 Florian Walsh
GBoverZZ.cpkg5 3.77 KB 04 Jun 2019 Elisa Palezzato
GBoverZZ.cpkgb 4.25 KB 17 Jun 2019 Elisa Palezzato
GBoverZZ.cpkgb 4.93 KB 19 Jun 2019 Elisa Palezzato
GBasisZ.cpkgb 10.6 KB 29 Aug 2019 Florian Walsh
GBasisZ-20220202.cpkg5 12.5 KB 02 Feb 2022 John Abbott
